Exception.InnerException Propriété

Définition

Obtient l'instance Exception qui a provoqué l'exception actuelle.Gets the Exception instance that caused the current exception.

public:
 property Exception ^ InnerException { Exception ^ get(); };
public Exception InnerException { get; }
member this.InnerException : Exception
Public ReadOnly Property InnerException As Exception

Valeur de propriété

Objet décrivant l'erreur qui a provoqué l'exception actuelle.An object that describes the error that caused the current exception. La propriété InnerException retourne la même valeur que celle transmise au constructeur Exception(String, Exception), ou null si la valeur de l'exception interne n'a pas été fournie au constructeur.The InnerException property returns the same value as was passed into the Exception(String, Exception) constructor, or null if the inner exception value was not supplied to the constructor. Cette propriété est en lecture seule.This property is read-only.

Implémente

Exemples

L’exemple suivant illustre la levée et l’interception d’une exception qui fait référence à une exception interne.The following example demonstrates throwing and catching an exception that references an inner exception.

using namespace System;

public ref class AppException: public Exception
{
public:
   AppException(String^ message ) : Exception(message)
   {}

   AppException(String^ message, Exception^ inner) : Exception(message, inner)
   {}
};

public ref class Example
{
public:
   void ThrowInner()
   {
      throw gcnew AppException("Exception in ThrowInner method.");
   }

   void CatchInner()
   {
      try {
         this->ThrowInner();
      }
      catch (AppException^ e) {
         throw gcnew AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
};

int main()
{
   Example^ ex = gcnew Example();
   try {
      ex->CatchInner();
   }
   catch (AppException^ e) {
      Console::WriteLine("In catch block of Main method.");
      Console::WriteLine("Caught: {0}", e->Message);
      if (e->InnerException != nullptr)
         Console::WriteLine("Inner exception: {0}", e->InnerException);
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
using System;

public class AppException : Exception
{
   public AppException(String message) : base (message)
   {}

   public AppException(String message, Exception inner) : base(message,inner) {}
}

public class Example
{
   public static void Main()
   {
      Example ex = new Example();

      try {
         ex.CatchInner();
      }
      catch(AppException e) {
         Console.WriteLine ("In catch block of Main method.");
         Console.WriteLine("Caught: {0}", e.Message);
         if (e.InnerException != null)
            Console.WriteLine("Inner exception: {0}", e.InnerException);
      }
   }

   public void ThrowInner ()
   {
      throw new AppException("Exception in ThrowInner method.");
   }

   public void CatchInner() 
   {
      try {
         this.ThrowInner();
      }
      catch (AppException e) {
         throw new AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
Public Class AppException : Inherits Exception
   Public Sub New(message As String)
      MyBase.New(message)
   End Sub
   
   Public Sub New(message As String, inner As Exception)
      MyBase.New(message, inner)
   End Sub
End Class

Public Class Example
   Public Shared Sub Main()
      Dim testInstance As New Example()
      Try
         testInstance.CatchInner()
      Catch e As AppException
         Console.WriteLine ("In catch block of Main method.")
         Console.WriteLine("Caught: {0}", e.Message)
         If e.InnerException IsNot Nothing Then
            Console.WriteLine("Inner exception: {0}", e.InnerException)
         End If
      End Try
   End Sub
   
   Public Sub ThrowInner()
      Throw New AppException("Exception in ThrowInner method.")
   End Sub
   
   Public Sub CatchInner()
      Try
         Me.ThrowInner()
      Catch e As AppException
         Throw New AppException("Error in CatchInner caused by calling the ThrowInner method.", e)
      End Try
   End Sub
End Class
' The example displays the following output:
'    In catch block of Main method.
'    Caught: Error in CatchInner caused by calling the ThrowInner method.
'    Inner exception: AppException: Exception in ThrowInner method.
'       at Example.CatchInner()

Remarques

Quand une exception X est levée en tant que résultat direct d’une exception Yprécédente, InnerException la propriété X de doit contenir une référence Yà.When an exception X is thrown as a direct result of a previous exception Y, the InnerException property of X should contain a reference to Y.

Utilisez la propriété InnerException pour obtenir l'ensemble d'exceptions ayant provoqué l'exception en cours.Use the InnerException property to obtain the set of exceptions that led to the current exception.

Vous pouvez créer une nouvelle exception qui intercepte une exception antérieure.You can create a new exception that catches an earlier exception. Le code qui gère la deuxième exception peut utiliser les informations supplémentaires de l’exception antérieure pour gérer l’erreur de manière plus appropriée.The code that handles the second exception can make use of the additional information from the earlier exception to handle the error more appropriately.

Supposez qu’il existe une fonction qui lit un fichier et met en forme les données à partir de ce fichier.Suppose that there is a function that reads a file and formats the data from that file. Dans cet exemple, lorsque le code essaie de lire le fichier, une IOException exception est levée.In this example, as the code tries to read the file, an IOException is thrown. La fonction intercepte IOException et lève une. FileNotFoundExceptionThe function catches the IOException and throws a FileNotFoundException. Peut être enregistré dans la InnerException propriété du FileNotFoundException, ce qui permet au code qui intercepte FileNotFoundException le d’examiner la cause de l’erreur initiale. IOExceptionThe IOException could be saved in the InnerException property of the FileNotFoundException, enabling the code that catches the FileNotFoundException to examine the cause of the initial error.

La InnerException propriété, qui contient une référence à l’exception interne, est définie lors de l’initialisation de l’objet exception.The InnerException property, which holds a reference to the inner exception, is set upon initialization of the exception object.

S’applique à